from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	address= DeclareSort('address')
	msg_sender= Const('msg_sender',address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	sender= Const('sender',address)
	LOW_LEVEL_CALL_send= Function('LOW_LEVEL_CALL_send',address,IntSort(),BoolSort())
	sent= Const('sent',BoolSort())
	_2solidity= Const('_2solidity',void)
	_1reentrancy_verifier= Int('_1reentrancy_verifier')
	_2reentrancy_verifier= Int('_2reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	msg_sender1= Const('msg_sender1',address)
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	bal1= Int('bal1')
	_1solidity1= Const('_1solidity1',void)
	sender1= Const('sender1',address)
	LOW_LEVEL_CALL_send1= Function('LOW_LEVEL_CALL_send1',address,IntSort(),BoolSort())
	sent1= Const('sent1',BoolSort())
	_2solidity1= Const('_2solidity1',void)
	_1reentrancy_verifier1= Int('_1reentrancy_verifier1')
	_2reentrancy_verifier1= Int('_2reentrancy_verifier1')
	_y12= Const('_y12',CONRT_EtherStore)
	_y13= Const('_y13',address)
	_y14= Int('_y14')
	_y15= Const('_y15',map)
	_y16= Const('_y16',address)
	_y17= Const('_y17',CONRT_EtherStore)
	_y18= Const('_y18',CONRT_EtherStore)
	_y19= Const('_y19',CONRT_EtherStore)
	_y20= Const('_y20',CONRT_EtherStore)
	_y21= Const('_y21',CONRT_EtherStore)
	_y22= Const('_y22',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y12],EtherStore_balances1(_y12)==EtherStore_balances(_y12)))
	_s.add(_1solidity1==_1solidity)
	_s.add(sender1==sender)
	_s.add(ForAll([_y13,_y14],LOW_LEVEL_CALL_send1(_y13,_y14)==LOW_LEVEL_CALL_send(_y13,_y14)))
	_s.add(_2solidity1==_2solidity)
	_s.add(ForAll([_y15,_y16,_y17,msg_sender],d1FaddressTuint256mapping1(_y15,_y16)==If(((d1FaddressTuint256mapping(EtherStore_balances(_y17),msg_sender))>(0)),If(LOW_LEVEL_CALL_send(sender,d1FaddressTuint256mapping(EtherStore_balances(_y17),msg_sender)),If(And(((_y15)==(EtherStore_balances(_y17))),((_y16)==(msg_sender))),0,If(((d1FaddressTuint256mapping(EtherStore_balances(_y17),msg_sender))>(0)),If(LOW_LEVEL_CALL_send(sender,d1FaddressTuint256mapping(EtherStore_balances(_y17),msg_sender)),If(And(((_y15)==(EtherStore_balances(_y17))),((_y16)==(msg_sender))),0,d1FaddressTuint256mapping(_y15,_y16)),d1FaddressTuint256mapping(_y15,_y16)),d1FaddressTuint256mapping(_y15,_y16))),If(((d1FaddressTuint256mapping(EtherStore_balances(_y17),msg_sender))>(0)),If(LOW_LEVEL_CALL_send(sender,d1FaddressTuint256mapping(EtherStore_balances(_y17),msg_sender)),If(And(((_y15)==(EtherStore_balances(_y17))),((_y16)==(msg_sender))),0,d1FaddressTuint256mapping(_y15,_y16)),d1FaddressTuint256mapping(_y15,_y16)),d1FaddressTuint256mapping(_y15,_y16))),d1FaddressTuint256mapping(_y15,_y16))))
	_s.add(ForAll([_y18,msg_sender],bal1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y18),msg_sender))>(0)),d1FaddressTuint256mapping(EtherStore_balances(_y18),msg_sender),d1FaddressTuint256mapping(EtherStore_balances(_y18),msg_sender))))
	_s.add(ForAll([_y19,msg_sender],sent1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y19),msg_sender))>(0)),LOW_LEVEL_CALL_send(sender,d1FaddressTuint256mapping(EtherStore_balances(_y19),msg_sender)),sent)))
	_s.add(ForAll([_y20,msg_sender],_1reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y20),msg_sender))>(0)),1,0)))
	_s.add(ForAll([_y21,msg_sender],_2reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y21),msg_sender))>(0)),If(((d1FaddressTuint256mapping(EtherStore_balances(_y21),msg_sender))>(0)),1,0),0)))
	_s.add(ForAll([_y22,msg_sender],((d1FaddressTuint256mapping(EtherStore_balances(_y22),msg_sender))>(0))))
	_s.add(Not(And((_1reentrancy_verifier1==1),(_2reentrancy_verifier1==1))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)